<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/EventBuilder/RCE/RCE_PCS.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_c45bab904c46ef8a733e5fe2ee88bd62.html">EventBuilder</a></li><li class="navelem"><a class="el" href="dir_e2570a0c9f787010e842f22c7bbb6659.html">RCE</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">RCE_PCS.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">IEEE</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>IEEE.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.uint64_array_t;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.uint8_array_t;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.uint10_array_t;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno"><a class="code" href="classRCE__PCS.html">    8</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classRCE__PCS.html">RCE_PCS</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;  <span class="vhdlkeyword">generic</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">4</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">8</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="vhdlchar">reset</span>           <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="vhdlchar">pll_powerdown</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="vhdlchar">tx_analogreset</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="vhdlchar">tx_digitalreset</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="vhdlchar">tx_refclk</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="vhdlchar">pll_locked</span>      <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="vhdlchar">tx</span>              <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlchar">clk_data</span>        <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="vhdlchar">data_wr</span>         <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="vhdlchar">k_data</span>          <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span><span class="vhdlchar">*</span><span class="vhdlchar">WORD_WIDTH</span>     <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="vhdlchar">data</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span><span class="vhdlchar">*</span><span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">*</span> <span class="vhdllogic"></span><span class="vhdllogic">8</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>  </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">RCE_PCS</span>;  </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="code" href="classRCE__PCS_1_1behavioral.html">   28</a></span>&#160;<span class="vhdlkeyword">architecture</span> behavioral <span class="vhdlkeyword">of</span> <a class="code" href="classRCE__PCS.html">RCE_PCS</a> is</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  <span class="vhdlkeyword">COMPONENT</span> <a class="code" href="enumencoder__8b10b.html">encoder_8b10b</a></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlkeyword">GENERIC</span> ( METHOD : <span class="comment">INTEGER</span> := <span class="vhdllogic"></span><span class="vhdllogic">1</span> );</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="vhdlkeyword">PORT</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;      (</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        clk     :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        rst     :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        kin_ena     :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        ein_ena     :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        ein_dat     :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC_VECTOR</span>(<span class="vhdllogic"></span><span class="vhdllogic">7</span> <span class="vhdlkeyword">DOWNTO</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        ein_rd      :    <span class="vhdlkeyword">IN</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        eout_val        :    <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        eout_dat        :    <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC_VECTOR</span>(<span class="vhdllogic"></span><span class="vhdllogic">9</span> <span class="vhdlkeyword">DOWNTO</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        eout_rdcomb     :    <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC</span>;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        eout_rdreg      :    <span class="vhdlkeyword">OUT</span> <span class="comment">STD_LOGIC</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    );</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;  <span class="vhdlkeyword">END</span> <span class="vhdlkeyword">COMPONENT</span>;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;  </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classRCE__LINK.html">RCE_LINK</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      pll_powerdown        : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);     </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;      tx_analogreset       : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      tx_digitalreset      : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;      tx_pll_refclk        : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>)   := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;      tx_pma_clkout        : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;      tx_serial_data       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;      tx_pma_parallel_data : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">319</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>) := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;      pll_locked           : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;      tx_cal_busy          : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;      reconfig_to_xcvr     : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">559</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>) := (<span class="vhdlkeyword">others</span> =&gt; &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;      reconfig_from_xcvr   : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span>(<span class="vhdllogic"></span><span class="vhdllogic">367</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>));</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">RCE_LINK</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">clk_pcs</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rdisp_in</span>       <span class="vhdlchar">:</span> <span class="vhdlchar">uint8_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">valid_10b</span>      <span class="vhdlchar">:</span> <span class="vhdlchar">uint8_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rdisp_out_comb</span> <span class="vhdlchar">:</span> <span class="vhdlchar">uint8_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">rdisp_out_reg</span>  <span class="vhdlchar">:</span> <span class="vhdlchar">uint8_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;  <span class="vhdlkeyword">type</span> <span class="vhdlchar">link_10b_array_t</span> <span class="vhdlkeyword">is</span> <span class="vhdlkeyword">array</span> <span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">of</span> <span class="vhdlchar">uint10_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">data_10b</span> <span class="vhdlchar">:</span> <span class="vhdlchar">link_10b_array_t</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;  </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">pma_parallel_data</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">TX_COUNT</span><span class="vhdlchar">*</span><span class="vhdlchar">WORD_WIDTH</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">10</span> <span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;  </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="vhdlkeyword">begin </span><span class="keyword"> -- <span class="vhdlkeyword">architecture</span> behavioral</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;  <span class="vhdlchar">clk_data</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_pcs</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <span class="vhdlchar">LINK_loop</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">for</span> <span class="vhdlchar">iLink</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">TX_COUNT</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">generate</span><span class="keyword"></span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="keyword">    --Build the </span><span class="vhdllogic">8b</span> <span class="vhdlkeyword">to</span> <span class="vhdllogic">10b</span> parallel encoders <span class="vhdlkeyword">for</span> this channel</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="vhdlkeyword">assert</span> <span class="vhdlchar">iLink</span> <span class="vhdlchar">/=</span> <span class="vhdllogic"></span><span class="vhdllogic">3</span> <span class="vhdlkeyword">report</span> <span class="keyword">&quot;iLInk: 3&quot;</span> <span class="vhdlkeyword">severity</span> <span class="vhdlchar">note</span>;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="vhdlkeyword">assert</span> <span class="vhdlchar">iLink</span> <span class="vhdlchar">/=</span> <span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlkeyword">report</span> <span class="keyword">&quot;iLInk: 2&quot;</span> <span class="vhdlkeyword">severity</span> <span class="vhdlchar">note</span>;</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="vhdlkeyword">assert</span> <span class="vhdlchar">iLink</span> <span class="vhdlchar">/=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">report</span> <span class="keyword">&quot;iLInk: 1&quot;</span> <span class="vhdlkeyword">severity</span> <span class="vhdlchar">note</span>;</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="vhdlkeyword">assert</span> <span class="vhdlchar">iLink</span> <span class="vhdlchar">/=</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">report</span> <span class="keyword">&quot;iLInk: 0&quot;</span> <span class="vhdlkeyword">severity</span> <span class="vhdlchar">note</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="vhdlchar">encoder_chain</span><span class="vhdlchar">:</span> <span class="vhdlkeyword">for</span> <span class="vhdlchar">iEnc</span> <span class="vhdlkeyword">in</span> <span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">generate</span><span class="keyword"></span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">      -- assumes LSB <span class="vhdlkeyword">out</span> first <span class="vhdlkeyword">on</span> PMA</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;      <span class="keyword"></span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="keyword">      --Registered disparity from the last clock</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;      <span class="vhdlchar">rdisp_in</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rdisp_out_reg</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="keyword">      --Un-registered disparity from the </span><span class="vhdllogic">8b10b</span> encoder previous <span class="vhdlkeyword">in</span> line</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;      <span class="vhdlchar">rdisp_in</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">rdisp_out_comb</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdlchar">WORD_WIDTH</span> <span class="vhdlchar">-</span> <span class="vhdllogic"></span><span class="vhdllogic">2</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;      encoder_8b10b_ch0: <a class="code" href="enumencoder__8b10b.html">encoder_8b10b</a></div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        <span class="vhdlkeyword">generic</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;          METHOD  =&gt; <span class="vhdllogic">1</span><span class="vhdlchar">)</span></div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;          clk          =&gt; clk_pcs <span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;          rst          =&gt; reset,</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;          kin_ena      =&gt; k_data <span class="vhdlchar">(</span><span class="vhdlchar">(</span>iLink*WORD_WIDTH<span class="vhdlchar">)</span>+iEnc<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;          ein_ena      =&gt; data_wr <span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;          ein_dat      =&gt; data<span class="vhdlchar">(</span> <span class="vhdlchar">(</span>iLink*WORD_WIDTH + iEnc+1<span class="vhdlchar">)</span>*8 -<span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span>  <span class="vhdlchar">(</span>iLink*WORD_WIDTH + iEnc<span class="vhdlchar">)</span>*8<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;          ein_rd       =&gt; rdisp_in<span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span><span class="vhdlchar">(</span>iEnc<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;          eout_val     =&gt; valid_10b<span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span><span class="vhdlchar">(</span>iEnc<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;          eout_dat     =&gt; data_10b<span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span><span class="vhdlchar">(</span>iEnc<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;          eout_rdcomb  =&gt; rdisp_out_comb<span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span><span class="vhdlchar">(</span>iEnc<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;          eout_rdreg   =&gt; rdisp_out_reg<span class="vhdlchar">(</span>iLink<span class="vhdlchar">)</span><span class="vhdlchar">(</span>iEnc<span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">      -- re-arrange into the PMA&#39;s input data format</span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;      <span class="vhdlchar">pma_parallel_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">80</span> <span class="vhdlchar">+</span> <span class="vhdlchar">iEnc</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">10</span> <span class="vhdlchar">+</span> <span class="vhdllogic"></span><span class="vhdllogic">9</span> <span class="vhdlkeyword">downto</span> <span class="vhdlchar">iLink</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">80</span> <span class="vhdlchar">+</span> <span class="vhdlchar">iEnc</span><span class="vhdlchar">*</span><span class="vhdllogic"></span><span class="vhdllogic">10</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">data_10b</span><span class="vhdlchar">(</span><span class="vhdlchar">iLink</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdlchar">iEnc</span><span class="vhdlchar">)</span>;      </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span> <span class="vhdlchar">encoder_chain</span>;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span> <span class="vhdlchar">LINK_loop</span>;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;  </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;  RCE_LINK_1: <a class="code" href="classRCE__LINK.html">RCE_LINK</a></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      pll_powerdown         =&gt; pll_powerdown,</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;      tx_analogreset        =&gt; tx_analogreset,</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;      tx_digitalreset       =&gt; tx_digitalreset,</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;      tx_pll_refclk<span class="vhdlchar">(</span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>      =&gt; tx_refclk ,</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;      tx_pma_clkout         =&gt; clk_pcs,</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;      tx_serial_data        =&gt; tx,</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;      tx_pma_parallel_data  =&gt; pma_parallel_data ,</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;      pll_locked            =&gt; pll_locked,</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;      tx_cal_busy           =&gt; <span class="vhdlkeyword">open</span>,</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;      reconfig_to_xcvr      =&gt; <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span>  =&gt; &#39;X&#39;<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;      reconfig_from_xcvr    =&gt; <span class="vhdlkeyword">open</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;  </div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">behavioral</span>;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:30 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
